



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用POI导出excel</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用POI导出excel</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-19 02:38:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>引言：对于excel的导出，首先是将数据写到WorkBook中，然后将book以流的形式写出即可，看代码：</p>
<pre class="prettyprint linenums">public void exportResultInfo(String fileName,String savePath) throws Exception{<br />
		HSSFWorkbook book = new HSSFWorkbook();<br />
    String[] greenUrlLabel = new String[] { "A", "B", "C",<br />
				"D", "E", "F" };<br />
		createSheet2(book, "result_info", greenUrlLabel, dataList);<br />
		downLoad(book, fileName, savePath);

	}</pre>
<p>部分代码解释： dataList是从数据中获取到的数据，也就是你想导出的数据</p>
<p>createSheet2(book, "result_info", greenUrlLabel, dataList);将数据写到book中</p>
<p>downLoad(book, fileName, savePath);将book写到excel中，对应的方法分别如下。</p>
<p>将数据写到book中：</p>
<pre class="prettyprint linenums">public void createSheet2(HSSFWorkbook book, String sheetName,<br />
			String[] label, List&lt;Object[]&gt; list) {

		// 单sheet 最大行数<br />
		// final Integer MAX_ROW_SIZE = 65536;<br />
		final Integer MAX_ROW_SIZE = 65535;<br />
		// 创建Sheet并设置sheetName<br />
		HSSFSheet sheet = null;

		// sheet number<br />
		int sheetNum = 0;

		// sheet data row<br />
		int rowCount = 0;<br />
		sheet = book.createSheet(sheetName);<br />
		sheetNum++;<br />
		// 首行填写表头<br />
		HSSFRow row00 = sheet.createRow(rowCount++);// 创建行 rowCount+1<br />
		for (int t = 0; t &lt; label.length; t++) {<br />
			HSSFCell cell0 = row00.createCell(t);<br />
			cell0.setCellValue(label[t]);<br />
		}

		// 数据行遍历<br />
		if (list != null &amp;&amp; list.size() &gt; 0) {<br />
			for (int i = 1; i &lt;= list.size(); i++) {

				// rowCount 为0时 新sheet初始化、表头数据初始化<br />
				if (rowCount == 0) {<br />
					// 创建新Sheet<br />
					sheet = book.createSheet(sheetName + "_" + sheetNum);<br />
					sheetNum++;

					// 首行填写表头<br />
					HSSFRow row0 = sheet.createRow(rowCount++);// 创建行<br />
					// rowCount+1<br />
					for (int t = 0; t &lt; label.length; t++) {<br />
						HSSFCell cell0 = row0.createCell(t);<br />
						cell0.setCellValue(label[t]);<br />
					}

				}

				// 创建数据行<br />
				HSSFRow row = sheet.createRow(rowCount++); // 第二行开始<br />
				Object[] objects = list.get(i - 1); // 填写数据集合的第一行

				// 列循环<br />
				if (objects != null &amp;&amp; objects.length &gt; 0) {<br />
					for (int j = 1; j &lt;= objects.length; j++) {<br />
						// 创建Cell<br />
						HSSFCell cell = row.createCell(j - 1);

						// 获取数据对象<br />
						Object obj = objects[j - 1];<br />
						// 填写数据<br />
						cell.setCellValue(new HSSFRichTextString(<br />
								getStringValueFromObject(obj)));<br />
					}<br />
				}

				// rowcount 归零判断 归零 新Sheet页面的开始<br />
				if (rowCount == MAX_ROW_SIZE) {<br />
					rowCount = 0;<br />
				}<br />
				Contants.expCount++;<br />
			}<br />
		}<br />
	}</pre>
<p>部分代码解释：由于早期的excel最大的行数只能到65535，所以在这地方做了判断，但数据条数大于这个数的时候，重新开一个sheet页，进行写入。</p>
<p>将book写到excel中：</p>
<pre class="prettyprint linenums">public String downLoad(HSSFWorkbook workbook, String fileName,<br />
			String savePath) throws IOException {<br />
		FileOutputStream fos = null;<br />
		ByteArrayOutputStream byteos = null;<br />
		try {<br />
			// 将HSSFWorkbook 写入字节流<br />
			byteos = new ByteArrayOutputStream();<br />
			workbook.write(byteos);

			// 获取所有字节及其长度<br />
			byte[] xlsBytes = byteos.toByteArray();<br />
			 int length = xlsBytes.length;<br />
			// 获取 流ServletOutputStream<br />
			File file = new File(savePath + File.separator + fileName);<br />
			if (!file.getParentFile().exists())<br />
				file.getParentFile().mkdirs();<br />
			if (!file.exists())<br />
				file.createNewFile();<br />
			fos = new FileOutputStream(file);<br />
			fos.write(xlsBytes);<br />
			System.out.println("End of transform the file :" + fileName);<br />
			fos.flush();<br />
		} catch (final IOException e) {<br />
			throw e;<br />
		} finally {<br />
			// 关闭字节流<br />
			if (byteos != null) {<br />
				byteos.close();<br />
			}<br />
			if (fos != null)<br />
				try {<br />
					fos.close();<br />
				} catch (IOException e) {<br />
					e.printStackTrace();<br />
				}<br />
		}<br />
		return null;<br />
	}</pre>
<p>这块就是将book写到对于的excel文件中，这里的filename可以自己给定。对于解析所需要的包的可以在<a href="http://download.csdn.net/detail/javaweiming/5849101" rel="external nofollow noreferrer">这里下载http://download.csdn.net/detail/javaweiming/5849101</a>。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwogzk9.html">Android 自动化测试&mdash;robotium&lpar;九&rpar;  Junit&lowbar;report测试报告重定向输出到终端SDCard</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z7l0v9.html">node 的express 如何接受以一个网站的url作为参数的路由</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kzynj8.html">Underscore&period;js 初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prr47q.html">配置&amp;lt&semi;authorization&amp;gt&semi;节（配置文件）</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ed7rm9.html">Codeigniter&colon;如何写一个好的Model</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw7knz8.html">winform学习1-----理解小概念-20160506</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xj1ve8.html">AMQ学习笔记 - 05&period; 客户端模板化</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xkkng9.html">EM 算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp1d239.html">SAE php 研究（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjjx2g8.html">pydev-python 链接mysql数据库（mac系统）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljl1xk9.html">WebBrowser编程简述</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz141e8.html">&lbrack;转&rsqb;Building a Basic Fuzzer with GDB&colon; The Five Minute GDB Scripting Tutorial</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljnex09.html">smarty的ASSIGN&lpar;&rpar;函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1l05jq.html">在Windows上安装配置MongoDB</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rr1d48.html">&lbrack;转&rsqb;angular 禁止缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m26nprq.html">Codeforces 442C Artem and Array （看题解&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4l0pk9.html">linux小倒腾</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjw71xq.html">Filberder教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn4k3gq.html">split命令详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv0z2mq.html">YFCC 100M数据集分析笔记</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnjjp4g8.html">redis安装和配置教程phpredis扩展安装测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdppngzq.html">SICP 习题 （1&period;37）解题总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljjg369.html">ABP应用层&mdash;&mdash;参数有效性验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojjzxlq.html">Oracle 多表关联更新</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjj3m38.html">Linux下的变化的主机名步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kkez09.html">批处理命令 For循环命令具体解释&excl;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpj02r9.html">Handler详细说明系列&lpar;六&rpar;&mdash;&mdash;View的post&lpar;&rpar;详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zox3k9.html">js之with</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz1zn08.html">【MongoDB数据库】Java MongoDB CRUD Example</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpjjdr9.html">ar命令提取&period;a时刻，一个错误 is a fat file &lpar;use libtool&lpar;1&rpar; or lipo&lpar;1&rpar; and ar&lpar;1&rpar; on it&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
